<template>

  <!-- Update thumbnail Form -->
  <form id="_update-thumbnail-form" class="w-full">

    <!-- Error messages -->
    <t-alert v-if="form.globalError" variant="error" class="mb-8" show>
      <p class="text-error">{{ form.globalError }}</p>
    </t-alert>

    <div class="flex mb-4">
      <!-- Thumbnail view/preview -->
      <div class="mr-4">
        <!-- User thumbnail -->
        <UserThumbnail
          v-if="thumbnailUrl.length === 0"
          :data="$root.auth.user().thumbnailBase64"
          :width="128"
        />
        <div v-else class="_user-thumbnail-container" style="width: 128px; height: 128px;">
          <img width="128" :src="thumbnailUrl"/>
        </div>
      </div>

      <!-- Input file: upload thumbnail -->
      <InputFile
        v-model="thumbnailValue"
        variant="primary"
        name="thumbnail"
        :label="$h.capitalize($t('user.thumbnail'))"
        :description="$t('user.uploadThumbnailDescription')"
        :error="getFieldErrorMessage('thumbnail')"
        labelClass="mb-4"
      />

    </div>

    <!-- Confirm button -->
    <Button
      variant="primary"
      :disabled="!isFormValid"
      @click.native="handleOk"
      inline
      class="mr-4"
    >
      {{ $t('global.save') | capitalize }}
    </Button>

    <!-- Cancel button -->
    <Button
      variant="error"
      :disabled="!isFormValid"
      @click.native="handleCancel"
      inline
    >
      {{ $t('global.cancel') | capitalize }}
    </Button>

  </form>

</template>

<script>
// vuex helpers
import { mapState, mapActions } from 'vuex'
// BaseForm
import BaseForm from '@/components/commons/form/BaseForm'
// utils
import { isNull } from '#utils'

/**
 * UpdateThumbnailForm component
 */
export default {
  name: 'UpdateThumbnailForm',
  extends: BaseForm,
  // 'form' option (see src/components/commons/form/BaseForm)
  form: {
    fields: {
      /**
       * thumbnail
       */
      thumbnail: {
        // Default: generate 'thumbnailValue' & 'thumbnailChanged'
        default: function () {
          return null
        },
        // Generate: 'thumbnailState'
        state: function () {
          return !this.isFieldInError('thumbnail')
        },
        // Generate: 'isThumbnailValid'
        isValid: function () {
          return !isNull(this.thumbnailValue)
        }
      }
    }
  },
  computed: {
    // Map state from Auth module
    ...mapState('Auth', [
      'passwordForSecurity'
    ]),
    /**
     * thumbnailUrl
     * @return {string}
     */
    thumbnailUrl: function () {
      if (this.thumbnailValue !== null && this.thumbnailValue instanceof File) {
        return URL.createObjectURL(this.thumbnailValue) // Transform blob to img src 'data' url
      } else {
        return ''
      }
    }
  },
  methods: {
    // Map actions from 'Auth' store module
    ...mapActions('Auth', [
      'loadCurrentUserData'
    ]),
    // Map actions from 'Users' store module
    ...mapActions('Users', [
      'updateUserThumbnail'
    ]),
    /**
     * Handle click on 'confirm' submit button.
     * @param {Object} evt - The event payload
     * @returns {void}
     */
    handleOk (evt) {
      // Prevent click
      evt.preventDefault()
      // Reset errors before
      this.resetErrors()
      // Display PaswordGuardModal
      this.$store.commit('SET_SYSTEM_SHOW_PASSWORD_GUARD_MODAL', true)
      // Define 'one-time' callback on global event
      this.$root.once('PASSWORD_SECURITY_CONFIRMED', async () => {
        await this.saveThumbnail() // Save thumbnail
        this.$store.commit('Auth/RESET_PASSWORD_FOR_SECURITY') // Reset passwordForSecurity
      })
    },
    /**
     * Handle click on 'cancel' button.
     * @param {Object} evt - The event payload
     * @returns {void}
     */
    handleCancel (evt) {
      // Prevent click
      evt.preventDefault()
      // Reset errors
      this.resetErrors()
      // Reset form
      this.resetForm()
    },
    /**
     * Handle click on thumbnail 'save' button.
     * @returns {void}
     */
    async saveThumbnail () {
      // Update user thumbnail
      const formData = new FormData()
      formData.append('thumbnail', this.thumbnailValue)
      formData.append('password', this.passwordForSecurity)
      const thumbnailResponse = await this.updateUserThumbnail({
        userId: this.$root.auth.user().id,
        data: formData
      })
      // If passed
      if (!(thumbnailResponse instanceof Error)) {
        // Refresh current user data
        await this.loadCurrentUserData()
        // Reset form
        this.resetForm()
      // Else parse server error
      } else {
        this.setFormErrors(thumbnailResponse) // Set form errors from response
      }
    }
  }
}
</script>
